diff -Naur tomato/release/src/router/pppd/solaris/Makefile.sol2 tomato121/release/src/router/pppd/solaris/Makefile.sol2
--- tomato/release/src/router/pppd/solaris/Makefile.sol2	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/solaris/Makefile.sol2	2008-04-22 21:44:05.000000000 +1000
@@ -1,7 +1,7 @@
 #
 # Makefile for STREAMS modules for Solaris 2.
 #
-# $Id: Makefile.sol2,v 1.1 2003/07/10 07:43:05 honor Exp $
+# $Id: Makefile.sol2,v 1.3 2004/11/15 00:57:54 carlsonj Exp $
 #
 
 include Makedefs.sol2
@@ -14,15 +14,15 @@
 all:	ppp ppp_ahdl ppp_comp
 
 ppp:	ppp.o ppp_mod.o
-	ld -r -o $@ ppp.o ppp_mod.o
+	$(LD) -r -o $@ ppp.o ppp_mod.o
 	chmod +x $@
 
 ppp_ahdl: ppp_ahdlc.o ppp_ahdlc_mod.o
-	ld -r -o $@ ppp_ahdlc.o ppp_ahdlc_mod.o
+	$(LD) -r -o $@ ppp_ahdlc.o ppp_ahdlc_mod.o
 	chmod +x $@
 
 ppp_comp: $(COMP_OBJS)
-	ld -r -o $@ $(COMP_OBJS)
+	$(LD) -r -o $@ $(COMP_OBJS)
 	chmod +x $@
 
 bsd-comp.o:	../modules/bsd-comp.c
@@ -47,11 +47,13 @@
 	$(CC) $(CFLAGS) -c $?
 
 install:
+	/usr/sbin/modunload -i 0
 	cp ppp ppp.conf /kernel/drv
 	cp ppp_comp ppp_ahdl /kernel/strmod
 	if grep clone:ppp /etc/minor_perm; then :; else \
 	  echo clone:ppp 0644 root sys >>/etc/minor_perm; fi
 	/usr/sbin/rem_drv ppp 2>/dev/null || true
+	/usr/sbin/modunload -i 0
 	/usr/sbin/add_drv ppp
 
 SRCS	= ppp.c ppp_mod.c ppp_ahdlc.c ppp_ahdlc_mod.c \
diff -Naur tomato/release/src/router/pppd/solaris/Makefile.sol2-64 tomato121/release/src/router/pppd/solaris/Makefile.sol2-64
--- tomato/release/src/router/pppd/solaris/Makefile.sol2-64	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/solaris/Makefile.sol2-64	2008-04-22 21:44:05.000000000 +1000
@@ -1,7 +1,7 @@
 #
 # Makefile for 64-bit STREAMS modules for Solaris 2.
 #
-# $Id: Makefile.sol2-64,v 1.1 2003/07/10 07:43:05 honor Exp $
+# $Id: Makefile.sol2-64,v 1.3 2004/11/15 00:57:54 carlsonj Exp $
 #
 
 include Makedefs.sol2
@@ -25,15 +25,16 @@
 	$(MAKE) -f $(STD_MAKE) all
 
 ppp:	$(LP64DIR)/ppp.o $(LP64DIR)/ppp_mod.o
-	ld -r -o $(LP64DIR)/$@ $(LP64DIR)/ppp.o $(LP64DIR)/ppp_mod.o
+	$(LD) -r -o $(LP64DIR)/$@ $(LP64DIR)/ppp.o $(LP64DIR)/ppp_mod.o
 	chmod +x $(LP64DIR)/$@
 
 ppp_ahdl: $(LP64DIR)/ppp_ahdlc.o $(LP64DIR)/ppp_ahdlc_mod.o
-	ld -r -o $(LP64DIR)/$@ $(LP64DIR)/ppp_ahdlc.o $(LP64DIR)/ppp_ahdlc_mod.o
+	$(LD) -r -o $(LP64DIR)/$@ $(LP64DIR)/ppp_ahdlc.o \
+		$(LP64DIR)/ppp_ahdlc_mod.o
 	chmod +x $(LP64DIR)/$@
 
 ppp_comp: $(COMP_OBJS)
-	ld -r -o $(LP64DIR)/$@ $(COMP_OBJS)
+	$(LD) -r -o $(LP64DIR)/$@ $(COMP_OBJS)
 	chmod +x $(LP64DIR)/$@
 
 $(LP64DIR)/bsd-comp.o: ../modules/bsd-comp.c
@@ -61,6 +62,7 @@
 	mkdir -m 755 -p $@
 
 install:
+	/usr/sbin/modunload -i 0
 	cp ppp ppp.conf /kernel/drv
 	cp ppp_comp ppp_ahdl /kernel/strmod
 	cp $(LP64DIR)/ppp /kernel/drv/$(LP64DIR)
@@ -68,6 +70,7 @@
 	if grep clone:ppp /etc/minor_perm; then :; else \
 	  echo clone:ppp 0644 root sys >>/etc/minor_perm; fi
 	/usr/sbin/rem_drv ppp 2>/dev/null || true
+	/usr/sbin/modunload -i 0
 	/usr/sbin/add_drv ppp
 
 SRCS	= ppp.c ppp_mod.c ppp_ahdlc.c ppp_ahdlc_mod.c \
diff -Naur tomato/release/src/router/pppd/solaris/Makefile.sol2-64x tomato121/release/src/router/pppd/solaris/Makefile.sol2-64x
--- tomato/release/src/router/pppd/solaris/Makefile.sol2-64x	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/solaris/Makefile.sol2-64x	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,89 @@
+#
+# Makefile for 64-bit STREAMS modules for Solaris 2 on x64
+#
+# $Id: Makefile.sol2-64x,v 1.1 2005/06/26 23:53:17 carlsonj Exp $
+#
+
+include Makedefs.sol2
+
+# Sun's cc flag for LP64 compilation / linkage
+COPTS 		+= -errwarn -xtarget=opteron -xarch=amd64 -xmodel=kernel \
+		   -Ui386 -U__i386 -D__amd64 -xO2
+
+# subdirectory where 64-bit objects / binaries will be placed
+LP64DIR		= amd64
+
+# Name of legacy Makefile (for 32-bit binaries)
+STD_MAKE	= Makefile.sol2
+
+COMP_OBJS	= $(LP64DIR)/ppp_comp.o $(LP64DIR)/bsd-comp.o \
+		$(LP64DIR)/deflate.o $(LP64DIR)/zlib.o $(LP64DIR)/vjcompress.o \
+		$(LP64DIR)/ppp_comp_mod.o
+
+all:	std_objs $(LP64DIR) ppp ppp_ahdl ppp_comp
+
+std_objs:
+	$(MAKE) -f $(STD_MAKE) all
+
+ppp:	$(LP64DIR)/ppp.o $(LP64DIR)/ppp_mod.o
+	$(LD) -r -o $(LP64DIR)/$@ $(LP64DIR)/ppp.o $(LP64DIR)/ppp_mod.o
+	chmod +x $(LP64DIR)/$@
+
+ppp_ahdl: $(LP64DIR)/ppp_ahdlc.o $(LP64DIR)/ppp_ahdlc_mod.o
+	$(LD) -r -o $(LP64DIR)/$@ $(LP64DIR)/ppp_ahdlc.o \
+		$(LP64DIR)/ppp_ahdlc_mod.o
+	chmod +x $(LP64DIR)/$@
+
+ppp_comp: $(COMP_OBJS)
+	$(LD) -r -o $(LP64DIR)/$@ $(COMP_OBJS)
+	chmod +x $(LP64DIR)/$@
+
+$(LP64DIR)/bsd-comp.o: ../modules/bsd-comp.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/deflate.o: ../modules/deflate.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp.o:	ppp.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_mod.o:	ppp_mod.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_ahdlc_mod.o: ppp_ahdlc_mod.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_ahdlc.o: ppp_ahdlc.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_comp.o: ppp_comp.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_comp_mod.o: ppp_comp_mod.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/vjcompress.o: ../modules/vjcompress.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/zlib.o:	../common/zlib.c
+	$(CC) $(CFLAGS) -c $? -o $@
+
+$(LP64DIR):
+	mkdir -m 755 -p $@
+
+install:
+	/usr/sbin/modunload -i 0
+	cp ppp ppp.conf /kernel/drv
+	cp ppp_comp ppp_ahdl /kernel/strmod
+	cp $(LP64DIR)/ppp /kernel/drv/$(LP64DIR)
+	cp $(LP64DIR)/ppp_comp $(LP64DIR)/ppp_ahdl /kernel/strmod/$(LP64DIR)
+	if grep clone:ppp /etc/minor_perm; then :; else \
+	  echo clone:ppp 0644 root sys >>/etc/minor_perm; fi
+	/usr/sbin/rem_drv ppp 2>/dev/null || true
+	/usr/sbin/modunload -i 0
+	/usr/sbin/add_drv ppp
+
+SRCS	= ppp.c ppp_mod.c ppp_ahdlc.c ppp_ahdlc_mod.c \
+	ppp_comp.c ../modules/bsd-comp.c ../modules/deflate.c \
+	../common/zlib.c ../modules/vjcompress.c ppp_comp_mod.c
+
+lint:
+	$(LINT64) $(SRCS)
+
+lint-32:
+	$(LINT32) $(SRCS)
+
+clean:
+	$(MAKE) -f $(STD_MAKE) clean
+	rm -f $(LP64DIR)/ppp $(LP64DIR)/ppp_comp $(LP64DIR)/ppp_ahdl $(LP64DIR)/*.o $(LP64DIR)/*~ $(LP64DIR)/core
diff -Naur tomato/release/src/router/pppd/solaris/Makefile.sol2gcc tomato121/release/src/router/pppd/solaris/Makefile.sol2gcc
--- tomato/release/src/router/pppd/solaris/Makefile.sol2gcc	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/solaris/Makefile.sol2gcc	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,68 @@
+#
+# Makefile for STREAMS modules for Solaris 2.
+#
+# $Id: Makefile.sol2gcc,v 1.4 2004/11/15 00:57:54 carlsonj Exp $
+#
+
+include Makedefs.sol2
+
+COPTS += -fno-builtin
+
+COMP_OBJS = ppp_comp.o bsd-comp.o deflate.o zlib.o vjcompress.o \
+	ppp_comp_mod.o
+
+all:	ppp ppp_ahdl ppp_comp
+
+ppp:	ppp.o ppp_mod.o
+	$(LD) -r -o $@ ppp.o ppp_mod.o
+	chmod +x $@
+
+ppp_ahdl: ppp_ahdlc.o ppp_ahdlc_mod.o
+	$(LD) -r -o $@ ppp_ahdlc.o ppp_ahdlc_mod.o
+	chmod +x $@
+
+ppp_comp: $(COMP_OBJS)
+	$(LD) -r -o $@ $(COMP_OBJS)
+	chmod +x $@
+
+bsd-comp.o:	../modules/bsd-comp.c
+	$(CC) $(CFLAGS) -c $?
+deflate.o:	../modules/deflate.c
+	$(CC) $(CFLAGS) -c $?
+ppp.o:	ppp.c
+	$(CC) $(CFLAGS) -c $?
+ppp_mod.o:	ppp_mod.c
+	$(CC) $(CFLAGS) -c $?
+ppp_ahdlc_mod.o: ppp_ahdlc_mod.c
+	$(CC) $(CFLAGS) -c $?
+ppp_ahdlc.o: ppp_ahdlc.c
+	$(CC) $(CFLAGS) -c $?
+ppp_comp.o: ppp_comp.c
+	$(CC) $(CFLAGS) -c $?
+ppp_comp_mod.o:	ppp_comp_mod.c
+	$(CC) $(CFLAGS) -c $?
+vjcompress.o:	../modules/vjcompress.c
+	$(CC) $(CFLAGS) -c $?
+zlib.o:	../common/zlib.c
+	$(CC) $(CFLAGS) -c $?
+
+install:
+	/usr/sbin/modunload -i 0
+	cp ppp ppp.conf /kernel/drv
+	cp ppp_comp ppp_ahdl /kernel/strmod
+	if grep clone:ppp /etc/minor_perm; then :; else \
+	  echo clone:ppp 0644 root sys >>/etc/minor_perm; fi
+	/usr/sbin/rem_drv ppp 2>/dev/null || true
+	/usr/sbin/modunload -i 0
+	/usr/sbin/add_drv ppp
+
+SRCS	= ppp.c ppp_mod.c ppp_ahdlc.c ppp_ahdlc_mod.c \
+	ppp_comp.c ../modules/bsd-comp.c ../modules/deflate.c \
+	../common/zlib.c ../modules/vjcompress.c ppp_comp_mod.c
+
+lint:
+	$(LINT32) $(SRCS)
+
+clean:
+	rm -f ppp ppp_comp ppp_ahdl *.o *~ core
+	rm -f *.ln
diff -Naur tomato/release/src/router/pppd/solaris/Makefile.sol2gcc-64 tomato121/release/src/router/pppd/solaris/Makefile.sol2gcc-64
--- tomato/release/src/router/pppd/solaris/Makefile.sol2gcc-64	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/solaris/Makefile.sol2gcc-64	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,88 @@
+#
+# Makefile for 64-bit STREAMS modules for Solaris 2.
+#
+# $Id: Makefile.sol2gcc-64,v 1.3 2004/11/15 00:57:54 carlsonj Exp $
+#
+
+include Makedefs.sol2
+
+# gcc flags for LP64 compilation / linkage
+COPTS           += -mcpu=v9 -m64 -mcmodel=medlow -mstack-bias -fno-builtin
+
+# subdirectory where 64-bit objects / binaries will be placed
+LP64DIR		= sparcv9
+
+# Name of legacy Makefile (for 32-bit binaries)
+STD_MAKE	= Makefile.sol2gcc
+
+COMP_OBJS	= $(LP64DIR)/ppp_comp.o $(LP64DIR)/bsd-comp.o \
+		$(LP64DIR)/deflate.o $(LP64DIR)/zlib.o $(LP64DIR)/vjcompress.o \
+		$(LP64DIR)/ppp_comp_mod.o
+
+all:	std_objs $(LP64DIR) ppp ppp_ahdl ppp_comp
+
+std_objs:
+	$(MAKE) -f $(STD_MAKE) all
+
+ppp:	$(LP64DIR)/ppp.o $(LP64DIR)/ppp_mod.o
+	$(LD) -r -o $(LP64DIR)/$@ $(LP64DIR)/ppp.o $(LP64DIR)/ppp_mod.o
+	chmod +x $(LP64DIR)/$@
+
+ppp_ahdl: $(LP64DIR)/ppp_ahdlc.o $(LP64DIR)/ppp_ahdlc_mod.o
+	$(LD) -r -o $(LP64DIR)/$@ $(LP64DIR)/ppp_ahdlc.o \
+		$(LP64DIR)/ppp_ahdlc_mod.o
+	chmod +x $(LP64DIR)/$@
+
+ppp_comp: $(COMP_OBJS)
+	$(LD) -r -o $(LP64DIR)/$@ $(COMP_OBJS)
+	chmod +x $(LP64DIR)/$@
+
+$(LP64DIR)/bsd-comp.o: ../modules/bsd-comp.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/deflate.o: ../modules/deflate.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp.o:	ppp.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_mod.o:	ppp_mod.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_ahdlc_mod.o: ppp_ahdlc_mod.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_ahdlc.o: ppp_ahdlc.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_comp.o: ppp_comp.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_comp_mod.o: ppp_comp_mod.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/vjcompress.o: ../modules/vjcompress.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/zlib.o:	../common/zlib.c
+	$(CC) $(CFLAGS) -c $? -o $@
+
+$(LP64DIR):
+	mkdir -m 755 -p $@
+
+install:
+	/usr/sbin/modunload -i 0
+	cp ppp ppp.conf /kernel/drv
+	cp ppp_comp ppp_ahdl /kernel/strmod
+	cp $(LP64DIR)/ppp /kernel/drv/$(LP64DIR)
+	cp $(LP64DIR)/ppp_comp $(LP64DIR)/ppp_ahdl /kernel/strmod/$(LP64DIR)
+	if grep clone:ppp /etc/minor_perm; then :; else \
+	  echo clone:ppp 0644 root sys >>/etc/minor_perm; fi
+	/usr/sbin/rem_drv ppp 2>/dev/null || true
+	/usr/sbin/modunload -i 0
+	/usr/sbin/add_drv ppp
+
+SRCS	= ppp.c ppp_mod.c ppp_ahdlc.c ppp_ahdlc_mod.c \
+	ppp_comp.c ../modules/bsd-comp.c ../modules/deflate.c \
+	../common/zlib.c ../modules/vjcompress.c ppp_comp_mod.c
+
+lint:
+	$(LINT64) $(SRCS)
+
+lint-32:
+	$(LINT32) $(SRCS)
+
+clean:
+	$(MAKE) -f $(STD_MAKE) clean
+	rm -f $(LP64DIR)/ppp $(LP64DIR)/ppp_comp $(LP64DIR)/ppp_ahdl $(LP64DIR)/*.o $(LP64DIR)/*~ $(LP64DIR)/core
diff -Naur tomato/release/src/router/pppd/solaris/Makefile.sol2gcc-64x tomato121/release/src/router/pppd/solaris/Makefile.sol2gcc-64x
--- tomato/release/src/router/pppd/solaris/Makefile.sol2gcc-64x	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/solaris/Makefile.sol2gcc-64x	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,94 @@
+#
+# Makefile for 64-bit STREAMS modules for Solaris 2 on x64 with gcc.
+#
+# $Id: Makefile.sol2gcc-64x,v 1.1 2005/06/26 23:53:17 carlsonj Exp $
+#
+
+include Makedefs.sol2
+
+# gcc flags for LP64 compilation / linkage
+COPTS           += -finline -fno-inline-functions -fno-builtin -fno-asm \
+		   -nodefaultlibs -D__sun -m64 -mtune=opteron -Ui386 \
+		   -U__i386 -fno-strict-aliasing -fno-unit-at-a-time \
+		   -fno-optimize-sibling-calls -O2 -D_ASM_INLINES \
+		   -ffreestanding -mcmodel=kernel -mno-red-zone -gdwarf-2 \
+		   -std=gnu89 -D_KERNEL -D_SYSCALL32 -D_SYSCALL32_IMPL \
+		   -D_ELF64 -Dsun -D__sun -D__SVR4
+
+# subdirectory where 64-bit objects / binaries will be placed
+LP64DIR		= amd64
+
+# Name of legacy Makefile (for 32-bit binaries)
+STD_MAKE	= Makefile.sol2gcc
+
+COMP_OBJS	= $(LP64DIR)/ppp_comp.o $(LP64DIR)/bsd-comp.o \
+		$(LP64DIR)/deflate.o $(LP64DIR)/zlib.o $(LP64DIR)/vjcompress.o \
+		$(LP64DIR)/ppp_comp_mod.o
+
+all:	std_objs $(LP64DIR) ppp ppp_ahdl ppp_comp
+
+std_objs:
+	$(MAKE) -f $(STD_MAKE) all
+
+ppp:	$(LP64DIR)/ppp.o $(LP64DIR)/ppp_mod.o
+	$(LD) -r -o $(LP64DIR)/$@ $(LP64DIR)/ppp.o $(LP64DIR)/ppp_mod.o
+	chmod +x $(LP64DIR)/$@
+
+ppp_ahdl: $(LP64DIR)/ppp_ahdlc.o $(LP64DIR)/ppp_ahdlc_mod.o
+	$(LD) -r -o $(LP64DIR)/$@ $(LP64DIR)/ppp_ahdlc.o \
+		$(LP64DIR)/ppp_ahdlc_mod.o
+	chmod +x $(LP64DIR)/$@
+
+ppp_comp: $(COMP_OBJS)
+	$(LD) -r -o $(LP64DIR)/$@ $(COMP_OBJS)
+	chmod +x $(LP64DIR)/$@
+
+$(LP64DIR)/bsd-comp.o: ../modules/bsd-comp.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/deflate.o: ../modules/deflate.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp.o:	ppp.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_mod.o:	ppp_mod.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_ahdlc_mod.o: ppp_ahdlc_mod.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_ahdlc.o: ppp_ahdlc.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_comp.o: ppp_comp.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/ppp_comp_mod.o: ppp_comp_mod.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/vjcompress.o: ../modules/vjcompress.c
+	$(CC) $(CFLAGS) -c $? -o $@
+$(LP64DIR)/zlib.o:	../common/zlib.c
+	$(CC) $(CFLAGS) -c $? -o $@
+
+$(LP64DIR):
+	mkdir -m 755 -p $@
+
+install:
+	/usr/sbin/modunload -i 0
+	cp ppp ppp.conf /kernel/drv
+	cp ppp_comp ppp_ahdl /kernel/strmod
+	cp $(LP64DIR)/ppp /kernel/drv/$(LP64DIR)
+	cp $(LP64DIR)/ppp_comp $(LP64DIR)/ppp_ahdl /kernel/strmod/$(LP64DIR)
+	if grep clone:ppp /etc/minor_perm; then :; else \
+	  echo clone:ppp 0644 root sys >>/etc/minor_perm; fi
+	/usr/sbin/rem_drv ppp 2>/dev/null || true
+	/usr/sbin/modunload -i 0
+	/usr/sbin/add_drv ppp
+
+SRCS	= ppp.c ppp_mod.c ppp_ahdlc.c ppp_ahdlc_mod.c \
+	ppp_comp.c ../modules/bsd-comp.c ../modules/deflate.c \
+	../common/zlib.c ../modules/vjcompress.c ppp_comp_mod.c
+
+lint:
+	$(LINT64) $(SRCS)
+
+lint-32:
+	$(LINT32) $(SRCS)
+
+clean:
+	$(MAKE) -f $(STD_MAKE) clean
+	rm -f $(LP64DIR)/ppp $(LP64DIR)/ppp_comp $(LP64DIR)/ppp_ahdl $(LP64DIR)/*.o $(LP64DIR)/*~ $(LP64DIR)/core
diff -Naur tomato/release/src/router/pppd/solaris/Makefile.top tomato121/release/src/router/pppd/solaris/Makefile.top
--- tomato/release/src/router/pppd/solaris/Makefile.top	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/solaris/Makefile.top	2008-04-22 21:44:05.000000000 +1000
@@ -1,10 +1,10 @@
 #
 # ppp top level makefile for SVR4 and Solaris 2
 #
-# $Id: Makefile.top,v 1.1 2003/07/10 07:43:05 honor Exp $
+# $Id: Makefile.top,v 1.3 2004/11/01 09:31:07 paulus Exp $
 #
 
-include solaris/Makedefs
+include Makedefs.com
 
 all:
 	cd chat; $(MAKE) all
@@ -13,18 +13,20 @@
 	cd pppdump; $(MAKE) all
 	cd solaris; $(MAKE) all
 
-install: $(BINDIR) $(MANDIR)/man8 install-progs install-etcppp
+install: $(BINDIR) $(MANDIR)/man8 install-progs
 
 install-progs:
 	cd chat; $(MAKE) install
 	cd pppd; $(MAKE) install
 	cd pppstats; $(MAKE) install
 	cd pppdump; $(MAKE) install
-	cd solaris; $(MAKE) install
 
 install-etcppp: $(ETCDIR) $(ETCDIR)/options $(ETCDIR)/pap-secrets \
 	$(ETCDIR)/chap-secrets
 
+install-modules:
+	cd solaris; $(MAKE) install
+
 $(ETCDIR)/options:
 	cp etc.ppp/options $@
 	chmod go-w $@
@@ -48,3 +50,6 @@
 	cd pppdump; $(MAKE) clean
 	cd solaris; $(MAKE) clean
 
+# no tests yet, one day...
+installcheck:
+	true
diff -Naur tomato/release/src/router/pppd/solaris/ppp_ahdlc.c tomato121/release/src/router/pppd/solaris/ppp_ahdlc.c
--- tomato/release/src/router/pppd/solaris/ppp_ahdlc.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/solaris/ppp_ahdlc.c	2008-04-22 21:44:05.000000000 +1000
@@ -18,30 +18,38 @@
  * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
  * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES
  *
- * Copyright (c) 1994 The Australian National University.
- * All rights reserved.
+ * Copyright (c) 1994 Paul Mackerras. All rights reserved.
  *
- * Permission to use, copy, modify, and distribute this software and its
- * documentation is hereby granted, provided that the above copyright
- * notice appears in all copies.  This software is provided without any
- * warranty, express or implied. The Australian National University
- * makes no representations about the suitability of this software for
- * any purpose.
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
  *
- * IN NO EVENT SHALL THE AUSTRALIAN NATIONAL UNIVERSITY BE LIABLE TO ANY
- * PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
- * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
- * THE AUSTRALIAN NATIONAL UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY
- * OF SUCH DAMAGE.
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
  *
- * THE AUSTRALIAN NATIONAL UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES,
- * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
- * ON AN "AS IS" BASIS, AND THE AUSTRALIAN NATIONAL UNIVERSITY HAS NO
- * OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
- * OR MODIFICATIONS.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
  *
- * $Id: ppp_ahdlc.c,v 1.1 2003/07/10 07:43:05 honor Exp $
+ * 3. The name(s) of the authors of this software must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission.
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Paul Mackerras
+ *     <paulus@samba.org>".
+ *
+ * THE AUTHORS OF THIS SOFTWARE DISCLAIM ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY
+ * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * $Id: ppp_ahdlc.c,v 1.5 2005/06/27 00:59:57 carlsonj Exp $
  */
 
 /*
@@ -50,6 +58,7 @@
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/stream.h>
+#include <sys/stropts.h>
 #include <sys/errno.h>
 
 #ifdef SVR4
@@ -75,6 +84,14 @@
 #define USE_MUTEX
 #endif /* SOL2 */
 
+#ifdef USE_MUTEX
+#define	MUTEX_ENTER(x)	mutex_enter(x)
+#define	MUTEX_EXIT(x)	mutex_exit(x)
+#else
+#define	MUTEX_ENTER(x)
+#define	MUTEX_EXIT(x)
+#endif
+
 /*
  * intpointer_t and uintpointer_t are signed and unsigned integer types 
  * large enough to hold any data pointer; that is, data pointers can be 
@@ -236,6 +253,7 @@
 MOD_OPEN(ahdlc_open)
 {
     ahdlc_state_t   *state;
+    mblk_t *mp;
 
     /*
      * Return if it's already opened
@@ -248,7 +266,7 @@
      * This can only be opened as a module
      */
     if (sflag != MODOPEN) {
-	return 0;
+	OPEN_ERROR(EINVAL);
     }
 
     state = (ahdlc_state_t *) ALLOC_NOSLEEP(sizeof(ahdlc_state_t));
@@ -261,7 +279,6 @@
 
 #if defined(USE_MUTEX)
     mutex_init(&state->lock, NULL, MUTEX_DEFAULT, NULL);
-    mutex_enter(&state->lock);
 #endif /* USE_MUTEX */
 
     state->xaccm[0] = ~0;	    /* escape 0x00 through 0x1f */
@@ -271,16 +288,18 @@
     state->flag_time = drv_usectohz(FLAG_TIME);
 #endif /* SOL2 */
 
-#if defined(USE_MUTEX)
-    mutex_exit(&state->lock);
-#endif /* USE_MUTEX */	
-
 #if defined(SUNOS4)
     ppp_ahdlc_count++;
 #endif /* SUNOS4 */
 
     qprocson(q);
-    
+
+    if ((mp = allocb(1, BPRI_HI)) != NULL) {
+	    mp->b_datap->db_type = M_FLUSH;
+	    *mp->b_wptr++ = FLUSHR;
+	    putnext(q, mp);
+    }
+
     return 0;
 }
 
@@ -300,17 +319,12 @@
 	return 0;
     }
 
-#if defined(USE_MUTEX)
-    mutex_enter(&state->lock);
-#endif /* USE_MUTEX */
-
     if (state->rx_buf != 0) {
 	freemsg(state->rx_buf);
 	state->rx_buf = 0;
     }
 
 #if defined(USE_MUTEX)
-    mutex_exit(&state->lock);
     mutex_destroy(&state->lock);
 #endif /* USE_MUTEX */
 
@@ -370,16 +384,12 @@
 		DPRINT1("ahdlc_wput/%d: PPPIO_XACCM b_cont = 0!\n", state->unit);
 		break;
 	    }
-#if defined(USE_MUTEX)
-	    mutex_enter(&state->lock);
-#endif /* USE_MUTEX */
+	    MUTEX_ENTER(&state->lock);
 	    bcopy((caddr_t)mp->b_cont->b_rptr, (caddr_t)state->xaccm,
 		  iop->ioc_count);
 	    state->xaccm[2] &= ~0x40000000;	/* don't escape 0x5e */
 	    state->xaccm[3] |= 0x60000000;	/* do escape 0x7d, 0x7e */
-#if defined(USE_MUTEX)
-	    mutex_exit(&state->lock);
-#endif /* USE_MUTEX */
+	    MUTEX_EXIT(&state->lock);
 	    iop->ioc_count = 0;
 	    error = 0;
 	    break;
@@ -391,14 +401,10 @@
 		DPRINT1("ahdlc_wput/%d: PPPIO_RACCM b_cont = 0!\n", state->unit);
 		break;
 	    }
-#if defined(USE_MUTEX)
-	    mutex_enter(&state->lock);
-#endif /* USE_MUTEX */
+	    MUTEX_ENTER(&state->lock);
 	    bcopy((caddr_t)mp->b_cont->b_rptr, (caddr_t)&state->raccm,
 		  sizeof(u_int32_t));
-#if defined(USE_MUTEX)
-	    mutex_exit(&state->lock);
-#endif /* USE_MUTEX */
+	    MUTEX_EXIT(&state->lock);
 	    iop->ioc_count = 0;
 	    error = 0;
 	    break;
@@ -412,13 +418,9 @@
 	    if (mp->b_cont != 0)
 		freemsg(mp->b_cont);
 	    mp->b_cont = np;
-#if defined(USE_MUTEX)
-	    mutex_enter(&state->lock);
-#endif /* USE_MUTEX */
+	    MUTEX_ENTER(&state->lock);
 	    *(int *)np->b_wptr = state->flags & RCV_FLAGS;
-#if defined(USE_MUTEX)
-	    mutex_exit(&state->lock);
-#endif /* USE_MUTEX */
+	    MUTEX_EXIT(&state->lock);
 	    np->b_wptr += sizeof(int);
 	    iop->ioc_count = sizeof(int);
 	    error = 0;
@@ -467,37 +469,25 @@
     case M_CTL:
 	switch (*mp->b_rptr) {
 	case PPPCTL_MTU:
-#if defined(USE_MUTEX)
-	    mutex_enter(&state->lock);
-#endif /* USE_MUTEX */
+	    MUTEX_ENTER(&state->lock);
 	    state->mtu = ((unsigned short *)mp->b_rptr)[1];
-#if defined(USE_MUTEX)
-	    mutex_exit(&state->lock);
-#endif /* USE_MUTEX */
-	    freemsg(mp);
+	    MUTEX_EXIT(&state->lock);
 	    break;
 	case PPPCTL_MRU:
-#if defined(USE_MUTEX)
-	    mutex_enter(&state->lock);
-#endif /* USE_MUTEX */
+	    MUTEX_ENTER(&state->lock);
 	    state->mru = ((unsigned short *)mp->b_rptr)[1];
-#if defined(USE_MUTEX)
-	    mutex_exit(&state->lock);
-#endif /* USE_MUTEX */
-	    freemsg(mp);
+	    MUTEX_EXIT(&state->lock);
 	    break;
 	case PPPCTL_UNIT:
-#if defined(USE_MUTEX)
-	    mutex_enter(&state->lock);
-#endif /* USE_MUTEX */
+	    MUTEX_ENTER(&state->lock);
 	    state->unit = mp->b_rptr[1];
-#if defined(USE_MUTEX)
-	    mutex_exit(&state->lock);
-#endif /* USE_MUTEX */
+	    MUTEX_EXIT(&state->lock);
 	    break;
 	default:
 	    putnext(q, mp);
+	    return 0;
 	}
+	freemsg(mp);
 	break;
 
     default:
@@ -527,22 +517,17 @@
     switch (mp->b_datap->db_type) {
     case M_DATA:
 	ahdlc_decode(q, mp);
-	freemsg(mp);
 	break;
 
     case M_HANGUP:
-#if defined(USE_MUTEX)
-	mutex_enter(&state->lock);
-#endif /* USE_MUTEX */
+	MUTEX_ENTER(&state->lock);
 	if (state->rx_buf != 0) {
 	    /* XXX would like to send this up for debugging */
 	    freemsg(state->rx_buf);
 	    state->rx_buf = 0;
 	}
 	state->flags = IFLUSH;
-#if defined(USE_MUTEX)
-	mutex_exit(&state->lock);
-#endif /* USE_MUTEX */
+	MUTEX_EXIT(&state->lock);
 	putnext(q, mp);
 	break;
 
@@ -578,9 +563,7 @@
     }
 
     state = (ahdlc_state_t *)q->q_ptr;
-#if defined(USE_MUTEX)
-    mutex_enter(&state->lock);
-#endif /* USE_MUTEX */
+    MUTEX_ENTER(&state->lock);
 
     /*
      * Allocate an output buffer large enough to handle a case where all
@@ -593,9 +576,7 @@
     outmp = allocb(outmp_len, BPRI_MED);
     if (outmp == NULL) {
 	state->stats.ppp_oerrors++;
-#if defined(USE_MUTEX)
-	mutex_exit(&state->lock);
-#endif /* USE_MUTEX */
+	MUTEX_EXIT(&state->lock);
 	putctl1(RD(q)->q_next, M_CTL, PPPCTL_OERROR);
 	return;
     }
@@ -689,12 +670,9 @@
     state->stats.ppp_obytes += msgdsize(outmp);
     state->stats.ppp_opackets++;
 
-#if defined(USE_MUTEX)
-    mutex_exit(&state->lock);
-#endif /* USE_MUTEX */
+    MUTEX_EXIT(&state->lock);
 
     putnext(q, outmp);
-    return;
 }
 
 /*
@@ -715,35 +693,14 @@
     ahdlc_state_t   *state;
     mblk_t	    *om;
     uchar_t	    *dp;
-    ushort_t	    fcs;
-#if defined(SOL2)
-    mblk_t	    *zmp;
-#endif /* SOL2 */
-
-#if defined(SOL2)
-    /*
-     * In case the driver (or something below) doesn't send
-     * data upstream in one message block, concatenate everything
-     */
-    if (!((mp->b_wptr - mp->b_rptr == msgdsize(mp)) && 
-         ((intpointer_t)mp->b_rptr % sizeof(intpointer_t) == 0))) {
-
-	zmp = msgpullup(mp, -1);
-	freemsg(mp);
-	mp = zmp;
-	if (mp == 0)
-	    return; 
-    }
-#endif /* SOL2 */
 
     state = (ahdlc_state_t *) q->q_ptr;
 
-#if defined(USE_MUTEX)
-    mutex_enter(&state->lock);
-#endif /* USE_MUTEX */
+    MUTEX_ENTER(&state->lock);
 
     state->stats.ppp_ibytes += msgdsize(mp);
 
+    for (; mp != 0; om = mp->b_cont, freeb(mp), mp = om)
     for (dp = mp->b_rptr; dp < mp->b_wptr; dp++) {
 
 	/*
@@ -860,9 +817,7 @@
 	}
     }
 
-#if defined(USE_MUTEX)
-    mutex_exit(&state->lock);
-#endif /* USE_MUTEX */
+    MUTEX_EXIT(&state->lock);
 }
 
 static int
